## openssh 8.4p1

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.109 2020/06/19 05:07:09 dtucker Exp $

tests:		prep file-tests t-exec unit

REGRESS_TARGETS=	t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12

# File based tests
file-tests: $(REGRESS_TARGETS)

# Interop tests are not run by default
interop interop-tests: t-exec-interop

prep:
	test "x${USE_VALGRIND}" = "x" || mkdir -p $(OBJ)/valgrind-out

clean:
	for F in $(CLEANFILES); do rm -f $(OBJ)$$F; done
	rm -rf $(OBJ).putty

distclean:	clean

LTESTS= 	connect \
		proxy-connect \
		connect-privsep \
		connect-uri \
		proto-version \
		proto-mismatch \
		exit-status \
		envpass \
		transfer \
		banner \
		rekey \
		dhgex \
		stderr-data \
		stderr-after-eof \
		broken-pipe \
		try-ciphers \
		yes-head \
		login-timeout \
		agent \
		agent-getpeereid \
		agent-timeout \
		agent-ptrace \
		agent-subprocess \
		keyscan \
		keygen-change \
		keygen-convert \
		keygen-moduli \
		key-options \
		scp \
		scp-uri \
		sftp \
		sftp-chroot \
		sftp-cmds \
		sftp-badcmds \
		sftp-batch \
		sftp-glob \
		sftp-perm \
		sftp-uri \
		reconfigure \
		dynamic-forward \
		forwarding \
		multiplex \
		reexec \
		brokenkeys \
		sshcfgparse \
		cfgparse \
		cfgmatch \
		cfgmatchlisten \
		percent \
		addrmatch \
		localcommand \
		forcecommand \
		portnum \
		keytype \
		kextype \
		cert-hostkey \
		cert-userkey \
		host-expand \
		keys-command \
		forward-control \
		integrity \
		krl \
		multipubkey \
		limit-keytype \
		hostkey-agent \
		keygen-knownhosts \
		hostkey-rotate \
		principals-command \
		cert-file \
		cfginclude \
		servcfginclude \
		allow-deny-users \
		authinfo \
		sshsig \
		keygen-comment


INTEROP_TESTS=	putty-transfer putty-ciphers putty-kex conch-ciphers
#INTEROP_TESTS+=ssh-com ssh-com-client ssh-com-keygen ssh-com-sftp

EXTRA_TESTS=	agent-pkcs11
#EXTRA_TESTS+= 	cipher-speed

USERNAME=		${LOGNAME}
CLEANFILES=	*.core actual agent-key.* authorized_keys_${USERNAME} \
		authorized_keys_${USERNAME}.* \
		authorized_principals_${USERNAME} \
		banner.in banner.out cert_host_key* cert_user_key* \
		copy.1 copy.2 data ed25519-agent ed25519-agent* \
		ed25519-agent.pub ed25519 ed25519.pub empty.in \
		expect failed-regress.log failed-ssh.log failed-sshd.log \
		hkr.* host.ecdsa-sha2-nistp256 host.ecdsa-sha2-nistp384 \
		host.ecdsa-sha2-nistp521 host.ssh-dss host.ssh-ed25519 \
		host.ssh-rsa host_ca_key* host_krl_* host_revoked_* key.* \
		key.dsa-* key.ecdsa-* key.ed25519-512 \
		key.ed25519-512.pub key.rsa-* keys-command-args kh.* \
		known_hosts known_hosts-cert known_hosts.* krl-* ls.copy \
		modpipe netcat no_identity_config \
		pidfile putty.rsa2 ready regress.log remote_pid \
		revoked-* rsa rsa-agent rsa-agent.pub rsa.pub rsa_ssh2_cr.prv \
		rsa_ssh2_crnl.prv scp-ssh-wrapper.exe \
		scp-ssh-wrapper.scp setuid-allowed sftp-server.log \
		sftp-server.sh sftp.log ssh-log-wrapper.sh ssh.log \
		ssh-rsa_oldfmt \
		ssh_config ssh_config.* ssh_proxy ssh_proxy_bak \
		ssh_proxy_envpass sshd.log sshd_config sshd_config_minimal \
		sshd_config.* sshd_proxy sshd_proxy.* sshd_proxy_bak \
		sshd_proxy_orig t10.out t10.out.pub t12.out t12.out.pub \
		t2.out t3.out t6.out1 t6.out2 t7.out t7.out.pub \
		t8.out t8.out.pub t9.out t9.out.pub testdata \
		user_*key* user_ca* user_key*

# Enable all malloc(3) randomisations and checks
TEST_ENV=      "MALLOC_OPTIONS=CFGJRSUX"

TEST_SSH_SSHKEYGEN?=ssh-keygen

CPPFLAGS=-I..

t1:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/rsa_ssh2.prv | diff - ${.CURDIR}/rsa_openssh.prv
	tr '\n' '\r' <${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_cr.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_cr.prv | diff - ${.CURDIR}/rsa_openssh.prv
	awk '{print $$0 "\r"}' ${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_crnl.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_crnl.prv | diff - ${.CURDIR}/rsa_openssh.prv

t2:
	cat ${.CURDIR}/rsa_openssh.prv > $(OBJ)/t2.out
	chmod 600 $(OBJ)/t2.out
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t2.out | diff - ${.CURDIR}/rsa_openssh.pub

t3:
	${TEST_SSH_SSHKEYGEN} -ef ${.CURDIR}/rsa_openssh.pub >$(OBJ)/t3.out
	${TEST_SSH_SSHKEYGEN} -if $(OBJ)/t3.out | diff - ${.CURDIR}/rsa_openssh.pub

t4:
	${TEST_SSH_SSHKEYGEN} -E md5 -lf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t4.ok

t5:
	${TEST_SSH_SSHKEYGEN} -Bf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t5.ok

t6:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.prv > $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.pub > $(OBJ)/t6.out2
	chmod 600 $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t6.out1 | diff - $(OBJ)/t6.out2

$(OBJ)/t7.out:
	${TEST_SSH_SSHKEYGEN} -q -t rsa -N '' -f $@

t7: $(OBJ)/t7.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t7.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t7.out > /dev/null

$(OBJ)/t8.out:
	${TEST_SSH_SSHKEYGEN} -q -t dsa -N '' -f $@

t8: $(OBJ)/t8.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t8.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t8.out > /dev/null

$(OBJ)/t9.out:
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -q -t ecdsa -N '' -f $@

t9: $(OBJ)/t9.out
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t9.out > /dev/null
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t9.out > /dev/null


$(OBJ)/t10.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -f $@

t10: $(OBJ)/t10.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t10.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t10.out > /dev/null

t11:
	${TEST_SSH_SSHKEYGEN} -E sha256 -lf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t11.ok

$(OBJ)/t12.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -C 'test-comment-1234' -f $@

t12: $(OBJ)/t12.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t12.out.pub | grep test-comment-1234 >/dev/null

t-exec:	${LTESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		skip=no; \
		for t in ""$${SKIP_LTESTS}; do \
			if [ "x$${t}.sh" = "x$${TEST}" ]; then skip=yes; fi; \
		done; \
		if [ "x$${skip}" = "xno" ]; then \
			echo "run test $${TEST}" ... 1>&2; \
			(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
		else \
			echo skip test $${TEST} 1>&2; \
		fi; \
	done

t-exec-interop:	${INTEROP_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

t-extra:	${EXTRA_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

# Not run by default
interop: ${INTEROP_TARGETS}

# Unit tests, built by top-level Makefile
unit:
	set -e ; if test -z "${SKIP_UNIT}" ; then \
		V="" ; \
		test "x${USE_VALGRIND}" = "x" || \
		    V=${.CURDIR}/valgrind-unit.sh ; \
		$$V ${.OBJDIR}/unittests/sshbuf/test_sshbuf ; \
		$$V ${.OBJDIR}/unittests/sshkey/test_sshkey \
			-d ${.CURDIR}/unittests/sshkey/testdata ; \
		$$V ${.OBJDIR}/unittests/sshsig/test_sshsig \
			-d ${.CURDIR}/unittests/sshsig/testdata ; \
		$$V ${.OBJDIR}/unittests/bitmap/test_bitmap ; \
		$$V ${.OBJDIR}/unittests/conversion/test_conversion ; \
		$$V ${.OBJDIR}/unittests/kex/test_kex ; \
		$$V ${.OBJDIR}/unittests/hostkeys/test_hostkeys \
			-d ${.CURDIR}/unittests/hostkeys/testdata ; \
		$$V ${.OBJDIR}/unittests/match/test_match ; \
		if test "x${TEST_SSH_UTF8}" = "xyes"  ; then \
			$$V ${.OBJDIR}/unittests/utf8/test_utf8 ; \
		fi \
	fi

=== regress/misc/fuzz-harness/Makefile ===
# NB. libssh and libopenbsd-compat should be built with the same sanitizer opts.
CXX=clang++-6.0
FUZZ_FLAGS=-fsanitize=address,undefined -fsanitize-coverage=edge,trace-pc
FUZZ_LIBS=-lFuzzer

CXXFLAGS=-O2 -g -Wall -Wextra -Wno-unused-parameter -I ../../.. $(FUZZ_FLAGS)
LDFLAGS=-L ../../.. -L ../../../openbsd-compat -g $(FUZZ_FLAGS)
LIBS=-lssh -lopenbsd-compat -lcrypto -lfido2 -lcbor $(FUZZ_LIBS)
COMMON_OBJS=ssh-sk-null.o

TARGETS=pubkey_fuzz sig_fuzz authopt_fuzz sshsig_fuzz \
	sshsigopt_fuzz privkey_fuzz

all: $(TARGETS)

.cc.o:
	$(CXX) $(CXXFLAGS) -c $< -o $@

pubkey_fuzz: pubkey_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ pubkey_fuzz.o $(COMMON_OBJS) $(LDFLAGS) $(LIBS)

sig_fuzz: sig_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ sig_fuzz.o $(COMMON_OBJS) $(LDFLAGS) $(LIBS)

authopt_fuzz: authopt_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ authopt_fuzz.o $(COMMON_OBJS) ../../../auth-options.o $(LDFLAGS) $(LIBS)

sshsig_fuzz: sshsig_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ sshsig_fuzz.o $(COMMON_OBJS) ../../../sshsig.o $(LDFLAGS) $(LIBS)

sshsigopt_fuzz: sshsigopt_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ sshsigopt_fuzz.o $(COMMON_OBJS) ../../../sshsig.o $(LDFLAGS) $(LIBS)

privkey_fuzz: privkey_fuzz.o $(COMMON_OBJS)
	$(CXX) -o $@ privkey_fuzz.o $(COMMON_OBJS) $(LDFLAGS) $(LIBS)

clean:
	-rm -f *.o $(TARGETS)

=== regress/unittests/hostkeys/Makefile ===
#	$OpenBSD: Makefile,v 1.8 2020/04/06 09:43:56 dtucker Exp $

PROG=test_hostkeys
SRCS=tests.c test_iterate.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addrmatch.c bitmap.c hostfile.c
SRCS+=ed25519.c hash.c ge25519.c fe25519.c sc25519.c verify.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== regress/unittests/kex/Makefile ===
#	$OpenBSD: Makefile,v 1.10 2020/04/06 09:43:56 dtucker Exp $

PROG=test_kex
SRCS=tests.c test_kex.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addrmatch.c bitmap.c packet.c dispatch.c canohost.c ssh_api.c
SRCS+=compat.c ed25519.c hash.c ge25519.c fe25519.c sc25519.c verify.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=	kex.c
SRCS+=	dh.c
SRCS+=	kexdh.c
SRCS+=	kexecdh.c
SRCS+=	kexgex.c
SRCS+=	kexgexc.c
SRCS+=	kexgexs.c
SRCS+=	kexc25519.c
SRCS+=	smult_curve25519_ref.c
SRCS+=	kexgen.c
SRCS+=	kexsntrup4591761x25519.c
SRCS+=	sntrup4591761.c
SRCS+=	utf8.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG}

.include <bsd.regress.mk>

LDADD+=-lz

=== regress/unittests/match/Makefile ===
#	$OpenBSD: Makefile,v 1.4 2017/12/21 03:01:49 djm Exp $

PROG=test_match
SRCS=tests.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=match.c misc.c log.c uidswap.c fatal.c ssherr.c addrmatch.c xmalloc.c
SRCS+=cleanup.c atomicio.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG}

.include <bsd.regress.mk>

=== regress/unittests/sshbuf/Makefile ===
#	$OpenBSD: Makefile,v 1.8 2020/01/26 00:09:50 djm Exp $

#	$OpenBSD: Makefile,v 1.8 2020/01/26 00:09:50 djm Exp $

PROG=test_sshbuf
SRCS=tests.c
SRCS+=test_sshbuf.c
SRCS+=test_sshbuf_getput_basic.c
SRCS+=test_sshbuf_getput_crypto.c
SRCS+=test_sshbuf_misc.c
SRCS+=test_sshbuf_fuzz.c
SRCS+=test_sshbuf_getput_fuzz.c
SRCS+=test_sshbuf_fixed.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c misc.c xmalloc.c log.c fatal.c ssherr.c cleanup.c

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS}

=== regress/unittests/sshkey/Makefile ===
#	$OpenBSD: Makefile,v 1.10 2020/04/06 09:43:56 dtucker Exp $

PROG=test_sshkey
SRCS=tests.c test_sshkey.c test_file.c test_fuzz.c common.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addrmatch.c bitmap.c
SRCS+=ed25519.c hash.c ge25519.c fe25519.c sc25519.c verify.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== regress/unittests/sshsig/Makefile ===
#	$OpenBSD: Makefile,v 1.1 2020/06/19 04:32:09 djm Exp $

PROG=test_sshsig
SRCS=tests.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addrmatch.c bitmap.c sshsig.c
SRCS+=ed25519.c hash.c ge25519.c fe25519.c sc25519.c verify.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== debian/changelog ===
openssh (1:8.4p1-6ubuntu2) impish; urgency=medium

  * Configure with ac_cv_func_closefrom=no to avoid an incompatibility
    with glibc 2.34's fallback_closefrom function (LP: #1944621)

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Tue, 21 Sep 2021 22:08:39 +0000

openssh (1:8.4p1-6ubuntu1) impish; urgency=low

  * Merge from Debian unstable (LP: #1941799). Remaining changes:
    - Cherry-pick seccomp fixes for glibc 2.33 thanks to Dave Jones for
      reports on armhf.

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Thu, 26 Aug 2021 12:51:02 -0600

openssh (1:8.4p1-6) unstable; urgency=medium

  [ Colin Watson ]
  * Rename ssh group to _ssh (closes: #990456).  It's only used by
    ssh-agent.
  * debian/tests/regress: Don't fail cleanup if haveged isn't running.
  * Backport from upstream:
    - Add includes.h to compat tests (closes: #992134, LP: #1939751).
  * Use "command -v" in maintainer scripts rather than "which".

  [ Athos Ribeiro ]
  * d/systemd/ssh@.service: preserve the systemd managed runtime directory to
    ensure parallel processes will not disrupt one another when halting
    (LP: #1905285) (closes: #934663)

 -- Colin Watson <cjwatson@debian.org>  Thu, 19 Aug 2021 11:04:01 +0100

openssh (1:8.4p1-5ubuntu2) impish; urgency=medium

  * d/systemd/ssh@.service: preserve the systemd managed runtime directory to
    ensure parallel processes will not disrupt one another when halting
    (LP: #1905285) (closes: #934663)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 05 Jul 2021 09:21:03 -0300

openssh (1:8.4p1-5ubuntu1) hirsute; urgency=medium

  * Merge with Debian; remaining changes:
    - Cherry-pick seccomp fixes for glibc 2.33 thanks to Dave Jones for
      reports on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 23 Mar 2021 15:27:12 +0100

openssh (1:8.4p1-5) unstable; urgency=high

  * CVE-2021-28041: Fix double free in ssh-agent(1) (closes: #984940).

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Mar 2021 09:59:40 +0000

openssh (1:8.4p1-4ubuntu2) hirsute; urgency=medium

  * SECURITY UPDATE: double-free memory corruption in ssh-agent
    - debian/patches/CVE-2021-28041.patch: set ext_name to NULL after
      freeing it so it doesn't get freed again later on in ssh-agent.c.
    - CVE-2021-28041

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 09 Mar 2021 08:44:15 -0500

openssh (1:8.4p1-4ubuntu1) hirsute; urgency=medium

  * Cherry-pick seccomp fixes for glibc 2.33 thanks to Dave Jones for
    reports on armhf.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 23 Feb 2021 12:55:46 +0000

openssh (1:8.4p1-4build2) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:35:45 +0100

openssh (1:8.4p1-4build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 15:19:19 +0000

openssh (1:8.4p1-4) unstable; urgency=medium

  * Avoid using libmd's <sha2.h> even if it's installed (closes: #982705).

 -- Colin Watson <cjwatson@debian.org>  Mon, 15 Feb 2021 10:25:17 +0000

openssh (1:8.4p1-3) unstable; urgency=medium

  * Backport from upstream:
    - Fix `EOF: command not found` error in ssh-copy-id (closes: #975540).

 -- Colin Watson <cjwatson@debian.org>  Wed, 02 Dec 2020 10:32:23 +0000

openssh (1:8.4p1-2) unstable; urgency=medium

  * Revert incorrect upstream patch that claimed to fix the seccomp sandbox
    on x32 but in fact broke it instead.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Oct 2020 17:41:13 +0000

openssh (1:8.4p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.4):
    - [SECURITY] ssh-agent(1): restrict ssh-agent from signing web
      challenges for FIDO/U2F keys.
    - [SECURITY] ssh-keygen(1): Enable FIDO 2.1 credProtect extension when
      generating a FIDO resident key.
    - ssh-keygen(1): the format of the attestation information optionally
      recorded when a FIDO key is generated has changed. It now includes the
      authenticator data needed to validate attestation signatures. 
    - The API between OpenSSH and the FIDO token middleware has changed and
      the SSH_SK_VERSION_MAJOR version has been incremented as a result.
      Third-party middleware libraries must support the current API version
      (7) to work with OpenSSH 8.4.
    - ssh(1), ssh-keygen(1): support for FIDO keys that require a PIN for
      each use. These keys may be generated using ssh-keygen using a new
      "verify-required" option. When a PIN-required key is used, the user
      will be prompted for a PIN to complete the signature operation.
    - sshd(8): authorized_keys now supports a new "verify-required" option
      to require FIDO signatures assert that the token verified that the
      user was present before making the signature. The FIDO protocol
      supports multiple methods for user-verification, but currently OpenSSH
      only supports PIN verification.
    - sshd(8), ssh-keygen(1): add support for verifying FIDO webauthn
      signatures. Webauthn is a standard for using FIDO keys in web
      browsers. These signatures are a slightly different format to plain
      FIDO signatures and thus require explicit support.
    - ssh(1): allow some keywords to expand shell-style ${ENV} environment
      variables. The supported keywords are CertificateFile, ControlPath,
      IdentityAgent and IdentityFile, plus LocalForward and RemoteForward
      when used for Unix domain socket paths.
    - ssh(1), ssh-agent(1): allow some additional control over the use of
      ssh-askpass via a new $SSH_ASKPASS_REQUIRE environment variable,
      including forcibly enabling and disabling its use (closes: #368657).
    - ssh(1): allow ssh_config(5)'s AddKeysToAgent keyword accept a time
      limit for keys in addition to its current flag options. Time-limited


=== debian/control ===
Source: openssh
Section: net
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
Build-Depends: autotools-dev,
               debhelper (>= 9.20160709~),
               debhelper-compat (= 9),
               dh-autoreconf,
               dh-exec,
               dh-runit (>= 2.8.8),
               dpkg-dev (>= 1.16.1~),
               libaudit-dev [linux-any],
               libedit-dev,
               libfido2-dev (>= 1.5.0) [linux-any],
               libgtk-3-dev <!pkg.openssh.nognome>,
               libkrb5-dev | heimdal-dev,
               libpam0g-dev | libpam-dev,
               libselinux1-dev [linux-any],
               libssl-dev (>= 1.1.0g),
               libsystemd-dev [linux-any],
               libwrap0-dev | libwrap-dev,
               pkg-config,
               zlib1g-dev (>= 1:1.2.3),
Standards-Version: 4.1.0
Uploaders: Colin Watson <cjwatson@debian.org>,
           Matthew Vernon <matthew@debian.org>,
Homepage: http://www.openssh.com/
Vcs-Git: https://salsa.debian.org/ssh-team/openssh.git
Vcs-Browser: https://salsa.debian.org/ssh-team/openssh

Package: openssh-client
Architecture: any
Depends: adduser (>= 3.10),
         dpkg (>= 1.7.0),
         passwd,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: xauth,
Conflicts: sftp,
Breaks: openssh-sk-helper
Replaces: openssh-sk-helper,
          ssh,
          ssh-krb5,
Suggests: keychain,
          libpam-ssh,
          monkeysphere,
          ssh-askpass,
Provides: rsh-client,
          ssh-client,
Multi-Arch: foreign
Description: secure shell (SSH) client, for secure access to remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the ssh, scp and sftp clients, the ssh-agent
 and ssh-add programs to make public key authentication more convenient,
 and the ssh-keygen, ssh-keyscan, ssh-copy-id and ssh-argv0 utilities.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 ssh replaces the insecure rsh, rcp and rlogin programs, which are
 obsolete for most purposes.

Package: openssh-server
Priority: optional
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser (>= 3.9),
         dpkg (>= 1.9.0),
         libpam-modules (>= 0.72-9),
         libpam-runtime (>= 0.76-14),
         lsb-base (>= 4.1+Debian3),
         openssh-client (= ${binary:Version}),
         openssh-sftp-server,
         procps,
         ucf (>= 0.28),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: default-logind | logind | libpam-systemd,
            ncurses-term,
            xauth,
            ${openssh-server:Recommends},
Conflicts: sftp,
           ssh-socks,
           ssh2,
Replaces: openssh-client (<< 1:7.9p1-8),
          ssh,
          ssh-krb5,
Breaks: ${runit:Breaks},
Suggests: molly-guard,
          monkeysphere,
          ssh-askpass,
          ufw,
Provides: ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) server, for secure access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the sshd server.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 sshd replaces the insecure rshd program, which is obsolete for most
 purposes.

Package: openssh-sftp-server
Priority: optional
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: openssh-server | ssh-server,
Breaks: openssh-server (<< 1:6.5p1-5),
Replaces: openssh-server (<< 1:6.5p1-5),
Enhances: openssh-server,
          ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) sftp server module, for SFTP access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the SFTP server module for the SSH server. It
 is needed if you want to access your SSH server with SFTP. The SFTP
 server module also works with other SSH daemons like dropbear.
 .
 OpenSSH's sftp and sftp-server implement revision 3 of the SSH filexfer
 protocol described in:
 .
  http://www.openssh.com/txt/draft-ietf-secsh-filexfer-02.txt
 .
 Newer versions of the draft will not be supported, though some features
 are individually implemented as extensions.

Package: openssh-tests
Priority: optional
Architecture: any
Depends: openssh-client (= ${binary:Version}),
         openssh-server (= ${binary:Version}),
         openssh-sftp-server (= ${binary:Version}),
         openssl,
         putty-tools (>= 0.67-2),
         python3-twisted,
         ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: foreign
Description: OpenSSH regression tests
 This package provides OpenSSH's regression test suite.  It is mainly
 intended for use with the autopkgtest system, though can also be run
 directly using /usr/lib/openssh/regress/run-tests.

Package: ssh
Priority: optional
Architecture: all
Pre-Depends: dpkg (>= 1.17.5),
Depends: openssh-client (>= ${binary:Version}),
         openssh-server (>= ${binary:Version}),
         ${misc:Depends},
Multi-Arch: foreign
Description: secure shell client and server (metapackage)
 This metapackage is a convenient way to install both the OpenSSH client
 and the OpenSSH server. It provides nothing in and of itself, so you
 may remove it if nothing depends on it.

Package: ssh-askpass-gnome
Build-Profiles: <!pkg.openssh.nognome>
Section: gnome
Priority: optional
Architecture: any
Depends: openssh-client | ssh (>= 1:1.2pre7-4),
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: ssh (<< 1:3.5p1-3),
Provides: ssh-askpass,
Multi-Arch: foreign
Description: interactive X program to prompt users for a passphrase for ssh-add
 This has been split out of the main openssh-client package so that
 openssh-client does not need to depend on GTK+.
 .
 You probably want the ssh-askpass package instead, but this is
 provided to add to your choice and/or confusion.

Package: openssh-client-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends},
XB-Installer-Menu-Item: 99999
Description: secure shell client for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the ssh client for use in debian-installer.

Package: openssh-server-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends},
Description: secure shell server for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the sshd server for use in debian-installer.
 Since it is expected to be used in specialized situations (e.g. S/390
 installs with no console), it does not provide any configuration.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_TESTS := yes
else
  RUN_TESTS :=
endif

ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  PARALLEL :=
else
  PARALLEL := \
	-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC := gcc
  PKG_CONFIG = pkg-config
else
  CC := $(DEB_HOST_GNU_TYPE)-gcc
  PKG_CONFIG = $(DEB_HOST_GNU_TYPE)-pkg-config
  RUN_TESTS :=
endif

# Change the version string to reflect distribution
SSH_EXTRAVERSION := $(DEB_VENDOR)-$(shell echo '$(DEB_VERSION)' | sed -e 's/.*-//')

UBUNTU := $(shell $(call dpkg_vendor_derives_from,Ubuntu))
ifeq ($(UBUNTU),yes)
DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
else
DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/games
endif
SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

ifeq ($(UBUNTU),yes)
server_recommends := ssh-import-id
else
server_recommends :=
endif

# Common path configuration.
confflags += --sysconfdir=/etc/ssh
confflags += --libexecdir=\$${prefix}/lib/openssh

# Common build options.
confflags += --disable-strip
confflags += --with-mantype=doc
confflags += --with-4in6
confflags += --with-privsep-path=/run/sshd
confflags += --with-pid-dir=/run

# The Hurd needs libcrypt for res_query et al.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
confflags += --with-libs=-lcrypt
endif

# Avoid using libmd even if it's installed; see
# https://bugs.debian.org/982705.
confflags += ac_cv_header_sha2_h=false

# Configure without closefrom to avoid chroot failures; see
# https://bugs.launchpad.net/ubuntu/+source/openssh/+bug/1944621
confflags += ac_cv_func_closefrom=no

# Everything above here is common to the deb and udeb builds.
confflags_udeb := $(confflags)

# Options specific to the deb build.
confflags += --with-tcp-wrappers
confflags += --with-pam
confflags += --with-libedit
confflags += --with-kerberos5=/usr
confflags += --with-ssl-engine
ifeq ($(DEB_HOST_ARCH_OS),linux)
confflags += --with-selinux
confflags += --with-audit=linux
confflags += --with-systemd
confflags += --with-security-key-builtin
endif

# The deb build wants xauth; the udeb build doesn't.
confflags += --with-xauth=/usr/bin/xauth
confflags_udeb += --without-xauth

# Default paths. The udeb build has /usr/games removed.
confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Compiler flags.
cflags := $(CPPFLAGS) $(CFLAGS)
cflags += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
cflags_udeb := -Os
cflags_udeb += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
confflags += --with-cflags='$(cflags)'
confflags_udeb += --with-cflags='$(cflags_udeb)'

# Linker flags.
confflags += --with-ldflags='$(strip -Wl,--as-needed $(LDFLAGS))'
confflags_udeb += --with-ldflags='-Wl,--as-needed'

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
  BUILD_PACKAGES += -Nopenssh-tests
endif

%:
	dh $@ --with=autoreconf,systemd,runit $(BUILD_PACKAGES)

autoreconf:
	autoreconf -f -i
	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub ./

override_dh_autoreconf-arch:
	dh_autoreconf debian/rules -- autoreconf

override_dh_autoreconf-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -Bdebian/build-deb -- $(confflags)
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_auto_configure -Bdebian/build-udeb -- $(confflags_udeb)
	# Avoid libnsl linkage. Ugh.
	perl -pi -e 's/ +-lnsl//' debian/build-udeb/config.status
	cd debian/build-udeb && ./config.status
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
	$(MAKE) -C debian/build-deb regress-prep
	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen
endif

ifeq ($(filter pkg.openssh.nognome,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C contrib gnome-ssh-askpass3 CC='$(CC) $(CPPFLAGS) $(CFLAGS) -Wall -Wl,--as-needed $(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG)
endif

override_dh_auto_build-indep:

override_dh_auto_test-arch:
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/build-deb unit compat-tests
	$(MAKE) -C debian/keygen-test
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf debian/build-deb debian/build-udeb
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/keygen-test clean
endif
	$(MAKE) -C contrib clean

override_dh_auto_install-arch:
	$(MAKE) -C debian/build-deb DESTDIR=`pwd`/debian/tmp install-nokeys

override_dh_auto_install-indep:

override_dh_install-arch:
	rm -f debian/tmp/etc/ssh/sshd_config

	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_install -popenssh-client-udeb -popenssh-server-udeb \
		--sourcedir=debian/build-udeb
endif

	# Remove version control tags to avoid unnecessary conffile
	# resolution steps for administrators.
	sed -i '/\$$OpenBSD:/d' \
		debian/openssh-server/etc/ssh/moduli \
		debian/openssh-client/etc/ssh/ssh_config

# We'd like to use dh_install --fail-missing here, but that doesn't work
# well in combination with dh-exec: it complains that files generated by
# dh-exec for architecture-dependent packages aren't installed.
override_dh_install-indep:
	rm -f debian/tmp/etc/ssh/sshd_config
	dh_install

override_dh_installdocs:
	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server
	dh_installdocs -popenssh-server -popenssh-sftp-server \
		--link-doc=openssh-client
	# Avoid breaking dh_installexamples later.
	mkdir -p debian/openssh-server/usr/share/doc/openssh-client

override_dh_systemd_enable:
	dh_systemd_enable -popenssh-server --name ssh ssh.service
	dh_systemd_enable -popenssh-server --name ssh --no-enable ssh.socket

override_dh_installinit:
	dh_installinit -R --name ssh

debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
ifeq ($(DEB_HOST_ARCH_OS),linux)
	sed 's/^@IF_KEYINIT@//' $< > $@
else
	sed '/^@IF_KEYINIT@/d' $< > $@
endif

override_dh_installpam: debian/openssh-server.sshd.pam
	dh_installpam --name sshd

override_dh_runit:
	dh_runit -popenssh-server

override_dh_fixperms-arch:
	dh_fixperms
	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign

# Tighten libssl dependencies to match the check in entropy.c.
override_dh_shlibdeps:
	dh_shlibdeps
	debian/adjust-openssl-dependencies

override_dh_gencontrol:
	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'

debian/faq.html:
	wget -O - http://www.openssh.com/faq.html | \
		sed 's,\(href="\)\(txt/\|[^":]*\.html\),\1http://www.openssh.com/\2,g' \
		> debian/faq.html

## openssh 8.7p1

=== regress/unittests/kex/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#	$OpenBSD: Makefile,v 1.10 2020/04/06 09:43:56 dtucker Exp $
+#	$OpenBSD: Makefile,v 1.12 2021/01/09 12:24:30 dtucker Exp $
 
 PROG=test_kex
 SRCS=tests.c test_kex.c
@@ -8,7 +8,7 @@
 SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
 SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
 SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
-SRCS+=addrmatch.c bitmap.c packet.c dispatch.c canohost.c ssh_api.c
+SRCS+=addr.c addrmatch.c bitmap.c packet.c dispatch.c canohost.c ssh_api.c
 SRCS+=compat.c ed25519.c hash.c ge25519.c fe25519.c sc25519.c verify.c
 SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
 SRCS+=ssh-ed25519-sk.c sk-usbhid.c
@@ -23,8 +23,8 @@
 SRCS+=	kexc25519.c
 SRCS+=	smult_curve25519_ref.c
 SRCS+=	kexgen.c
-SRCS+=	kexsntrup4591761x25519.c
-SRCS+=	sntrup4591761.c
+SRCS+=	kexsntrup761x25519.c
+SRCS+=	sntrup761.c
 SRCS+=	utf8.c
 
 SRCS+=digest-openssl.c

=== regress/unittests/misc/Makefile ===
#	$OpenBSD: Makefile,v 1.7 2021/05/21 03:48:07 djm Exp $

PROG=test_misc
SRCS=tests.c
SRCS+=	test_convtime.c
SRCS+=	test_expand.c
SRCS+=	test_parse.c
SRCS+=	test_argv.c
SRCS+=	test_strdelim.c

# From usr.bin/ssh/Makefile.inc
SRCS+=	sshbuf.c
SRCS+=	sshbuf-getput-basic.c
SRCS+=	sshbuf-misc.c
SRCS+=	ssherr.c
SRCS+=	log.c
SRCS+=	xmalloc.c
SRCS+=	misc.c
SRCS+=	match.c
SRCS+=	addr.c
SRCS+=	addrmatch.c

# From usr.bin/ssh/sshd/Makefile
SRCS+=	atomicio.c cleanup.c fatal.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG}

.include <bsd.regress.mk>

=== debian/changelog ===
openssh (1:8.7p1-4.0nosystemd1) nosystemd; urgency=medium

  * remove hard dependncy on libsystemd0/libelogind0 

 -- anticapitalista <antix@operamail.com>  Wed, 29 Dec 2021 17:51:00 +0200

openssh (1:8.7p1-4) unstable; urgency=medium

  [ Daniel Baumann ]
  * Fix typo in openssh-client.alternatives (closes: #1002803).

  [ Colin Watson ]
  * Further clarify socket activation instructions.

 -- Colin Watson <cjwatson@debian.org>  Wed, 29 Dec 2021 12:08:38 +0000

openssh (1:8.7p1-3) unstable; urgency=medium

  * Include unit test binaries in openssh-tests even if building with
    DEB_BUILD_OPTIONS=nocheck.
  * Install built version of sshd_config, with corrected PATH and PidFile.
  * Upgrade to debhelper v13.
  * debian/copyright: Use HTTPS in Source field.
  * Update renamed Lintian tag name in Lintian override.
  * debian/watch: Upgrade to version 4.
  * Clarify instructions for using socket activation to avoid accidental
    attempts to start the non-socket-activated service that can result in
    systems without a running sshd (closes: #1001320).
  * Remove maintainer script code for upgrades from before Debian 9.
  * Make the sysvinit script provide "ssh" as well as "sshd".
  * Set Rules-Requires-Root: no.
  * Use dh_installalternatives.
  * Simplify some debhelper overrides slightly.

 -- Colin Watson <cjwatson@debian.org>  Wed, 29 Dec 2021 01:12:00 +0000

openssh (1:8.7p1-2) unstable; urgency=medium

  * Backport from upstream:
    - Avoid NULL deref in -Y find-principals (closes: #999593).

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Nov 2021 13:40:50 +0000

openssh (1:8.7p1-1) unstable; urgency=medium

  * debian/upstream/signing-key.asc: Update from upstream.
  * New upstream release (https://www.openssh.com/releasenotes.html#8.7p1):
    - scp(1): this release changes the behaviour of remote to remote copies
      (e.g. "scp host-a:/path host-b:") to transfer through the local host
      by default (closes: #734386, LP: #1462758). This was previously
      available via the -3 flag. A -R flag has been added to select the old
      behaviour.
    - ssh(1)/sshd(8): both the client and server are now using a stricter
      configuration file parser.
    - ssh(1): when using SSHFP DNS records for host key verification, ssh(1)
      will verify all matching records instead of just those with the
      specific signature type requested.
    - ssh-keygen(1): when generating a FIDO key and specifying an explicit
      attestation challenge (using -Ochallenge), the challenge will now be
      hashed by the builtin security key middleware.
    - sshd(8): environment="..." directives in authorized_keys files are now
      first-match-wins and limited to 1024 discrete environment variable
      names.
    - scp(1): experimental support for transfers using the SFTP protocol as
      a replacement for the venerable SCP/RCP protocol that it has
      traditionally used. SFTP offers more predictable filename handling and
      does not require expansion of glob(3) patterns via the shell on the
      remote side.
      SFTP support may be enabled via a temporary scp -s flag. It is
      intended for SFTP to become the default transfer mode in the near
      future, at which time the -s flag will be removed. The -O flag exists
      to force use of the original SCP/RCP protocol for cases where SFTP may
      be unavailable or incompatible.
    - sftp-server(8): add a protocol extension to support expansion of ~/
      and ~user/ prefixed paths. This was added to support these paths when
      used by scp(1) while in SFTP mode.
    - ssh(1): add a ForkAfterAuthentication ssh_config(5) counterpart to the
      ssh(1) -f flag. GHPR231
    - ssh(1): add a StdinNull directive to ssh_config(5) that allows the
      config file to do the same thing as -n does on the ssh(1) command-
      line. GHPR231
    - ssh(1): add a SessionType directive to ssh_config, allowing the
      configuration file to offer equivalent control to the -N (no session)
      and -s (subsystem) command-line flags (closes: #609122).
    - ssh-keygen(1): allowed signers files used by ssh-keygen(1) signatures
      now support listing key validity intervals alongside they key, and
      ssh-keygen(1) can optionally check during signature verification
      whether a specified time falls inside this interval. This feature is
      intended for use by git to support signing and verifying objects using
      ssh keys.
    - ssh-keygen(8): support printing of the full public key in a sshsig
      signature via a -Oprint-pubkey flag.
    - ssh(1)/sshd(8): start time-based re-keying exactly on schedule in the
      client and server mainloops. Previously the re-key timeout could
      expire but re-keying would not start until a packet was sent or
      received, causing a spin in select() if the connection was quiescent.
    - ssh-keygen(1): avoid Y2038 problem in printing certificate validity
      lifetimes. Dates past 2^31-1 seconds since epoch were displayed
      incorrectly on some platforms.
    - scp(1): allow spaces to appear in usernames for local to remote and
      scp -3 remote to remote copies.
    - ssh(1)/sshd(8): remove references to ChallengeResponseAuthentication
      in favour of KbdInteractiveAuthentication. The former is what was in
      SSHv1, the latter is what is in SSHv2 (RFC4256) and they were treated
      as somewhat but not entirely equivalent. We retain the old name as a
      deprecated alias so configuration files continue to work as well as a
      reference in the man page for people looking for it.
    - ssh(1)/ssh-add(1)/ssh-keygen(1): fix decoding of X.509 subject name
      when extracting a key from a PKCS#11 certificate.
    - ssh(1): restore blocking status on stdio fds before close. ssh(1)
      needs file descriptors in non-blocking mode to operate but it was not
      restoring the original state on exit. This could cause problems with


=== debian/rules ===
--- 
+++ 
@@ -85,7 +85,6 @@
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 confflags += --with-selinux
 confflags += --with-audit=linux
-confflags += --with-systemd
 confflags += --with-security-key-builtin
 endif
 
@@ -114,14 +113,7 @@
 endif
 
 %:
-	dh $@ --with=autoreconf,systemd,runit $(BUILD_PACKAGES)
-
-autoreconf:
-	autoreconf -f -i
-	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub ./
-
-override_dh_autoreconf-arch:
-	dh_autoreconf debian/rules -- autoreconf
+	dh $@ --with=runit $(BUILD_PACKAGES)
 
 override_dh_autoreconf-indep:
 
@@ -139,7 +131,7 @@
 override_dh_auto_build-arch:
 	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
 	$(MAKE) -C debian/build-deb regress-prep
-	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries
+	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries regress-unit-binaries
 ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen
 endif
@@ -171,26 +163,22 @@
 override_dh_auto_install-indep:
 
 override_dh_install-arch:
-	rm -f debian/tmp/etc/ssh/sshd_config
-
-	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
+	# Remove version control tags to avoid unnecessary conffile
+	# resolution steps for administrators.
+	sed -i '/\$$OpenBSD:/d' \
+		debian/tmp/etc/ssh/moduli \
+		debian/tmp/etc/ssh/ssh_config \
+		debian/tmp/etc/ssh/sshd_config
+
+	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb
 ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	dh_install -popenssh-client-udeb -popenssh-server-udeb \
 		--sourcedir=debian/build-udeb
 endif
 
-	# Remove version control tags to avoid unnecessary conffile
-	# resolution steps for administrators.
-	sed -i '/\$$OpenBSD:/d' \
-		debian/openssh-server/etc/ssh/moduli \
-		debian/openssh-client/etc/ssh/ssh_config
-
-# We'd like to use dh_install --fail-missing here, but that doesn't work
-# well in combination with dh-exec: it complains that files generated by
-# dh-exec for architecture-dependent packages aren't installed.
-override_dh_install-indep:
-	rm -f debian/tmp/etc/ssh/sshd_config
-	dh_install
+	# This can't be done using dh_link, because it's needed earlier by
+	# dh_installalternatives.
+	ln -sf ssh debian/openssh-client/usr/bin/slogin
 
 override_dh_installdocs:
 	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server
@@ -199,10 +187,6 @@
 	# Avoid breaking dh_installexamples later.
 	mkdir -p debian/openssh-server/usr/share/doc/openssh-client
 
-override_dh_systemd_enable:
-	dh_systemd_enable -popenssh-server --name ssh ssh.service
-	dh_systemd_enable -popenssh-server --name ssh --no-enable ssh.socket
-
 override_dh_installinit:
 	dh_installinit -R --name ssh
 
@@ -219,13 +203,11 @@
 override_dh_runit:
 	dh_runit -popenssh-server
 
-override_dh_fixperms-arch:
-	dh_fixperms
+execute_after_dh_fixperms-arch:
 	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign
 
 # Tighten libssl dependencies to match the check in entropy.c.
-override_dh_shlibdeps:
-	dh_shlibdeps
+execute_after_dh_shlibdeps:
 	debian/adjust-openssl-dependencies
 
 override_dh_gencontrol:

## openssh 8.8p1

=== debian/changelog ===
openssh (1:8.8p1-1.0nosystemd1) nosystemd; urgency=medium

  * remove hard dependency on libsystemd0/libelogind0 

 -- anticapitalista <antix@operamail.com>  Wed, 16 Feb 2022 14:42:30 +0200

openssh (1:8.8p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#8.8p1,
    closes: #996391):
    - This release disables RSA signatures using the SHA-1 hash algorithm by
      default.  (Existing RSA keys may still be used and do not need to be
      replaced; see NEWS.Debian if you have problems connecting to old SSH
      servers.)
    - ssh(1): allow the ssh_config(5) CanonicalizePermittedCNAMEs directive
      to accept a "none" argument to specify the default behaviour.
    - scp(1): when using the SFTP protocol, continue transferring files
      after a transfer error occurs, better matching original scp/rcp
      behaviour.
    - ssh(1): fixed a number of memory leaks in multiplexing,
    - ssh-keygen(1): avoid crash when using the -Y find-principals command.
    - A number of documentation and manual improvements.
    - ssh(1)/sshd(8): some fixes to the pselect(2) replacement compatibility
      code.
  * Work around missing RSA SHA-2 signature support in conch until the
    upstream fix lands in Debian.

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Feb 2022 19:20:21 +0000
